//! \example _tests/fsAssert/main.cpp
//---------------------------------------------------------------------------
#include <fs/sys/fsAssert.h>

#include <stdio.h> // printf
//---------------------------------------------------------------------------
int main()
{
    struct Local_t
    {
        static bool Test()
        {
            printf("Local_t::Test()\n");
            return true;
        }
    };
            
    // Note that in the case of FS_ASSERT_... the expression is not
    // evaluated in the release mode !!!

    FS_ASSERT(Local_t::Test());
    FS_ASSERT_MSG(Local_t::Test(), "Problem description...");
    FS_ASSERT_BEEP(Local_t::Test());
    FS_VERIFY(Local_t::Test());
    FS_VERIFY_MSG(Local_t::Test(), "Problem description...");
    FS_VERIFY_BEEP(Local_t::Test());
    FS_STATIC_ASSERT(sizeof(char) < sizeof(int));
    
    printf("---\n");
    
    FS_ASSERT(!Local_t::Test());
    FS_ASSERT_MSG(!Local_t::Test(), "Problem description...");
    FS_ASSERT_BEEP(!Local_t::Test());
    FS_VERIFY(!Local_t::Test());
    FS_VERIFY_MSG(!Local_t::Test(), "Problem description...");
    FS_VERIFY_BEEP(!Local_t::Test());
            
    return 0;
}
//---------------------------------------------------------------------------