//! \example _tests/fsBitBlt/main.cpp
//---------------------------------------------------------------------------
#include <fs/ras/fsBitBlt.h>

#include <stdio.h> // printf
#include <memory.h> // memset
//---------------------------------------------------------------------------
int main()
{
    using namespace fs::ras;
    
    const unsigned char aSrcData[9 * 3] = {
     1, 1, 1,   2, 2, 2,   3, 3, 3,
     4, 4, 4,   5, 5, 5,   6, 6, 6,
     7, 7, 7,   8, 8, 8,   9, 9, 9,
    };
    unsigned char aDstData[9 * 3];
    
    ::printf("--- original image data ---");
    for(int i = 0; i < 9 * 3; ++i) { if(i % 3 == 0) printf(" ");
     if(i % 9 == 0) printf("\n"); ::printf("%d", aSrcData[i]); }
        
    ::memset(aDstData, 0, sizeof(aDstData));
    BitBlt<nsBitBlt::Cl888CpPcy_t>(
     reinterpret_cast<const nsBitBlt::PxFmt888_t *>(aSrcData),
     3, 3, // src size
     0, 0, 3, 3, // src pos, reg size
     reinterpret_cast<nsBitBlt::PxFmt888_t *>(aDstData),
     3, 3, // dst size
     -1, -1 // dst pos
    );
    
    ::printf("\n--- move [-1, -1] ---");
    for(int i = 0; i < 9 * 3; ++i) { if(i % 3 == 0) printf(" ");
    if(i % 9 == 0) printf("\n"); ::printf("%d", aDstData[i]); }
        
    ::memset(aDstData, 0, sizeof(aDstData));
    BitBlt<nsBitBlt::Cl888CpPcy_t>(
     reinterpret_cast<const nsBitBlt::PxFmt888_t *>(aSrcData),
     3, 3, // src size
     0, 0, 2, 2, // src pos, reg size
     reinterpret_cast<nsBitBlt::PxFmt888_t *>(aDstData),
     3, 3, // dst size
     0, 0, // dst pos
     1, 0, 2, 3 // clipping
    );
    
    ::printf("\n--- smaller region [2, 2] & clip x~<1, 2) y~<0, 3) ---");
    for(int i = 0; i < 9 * 3; ++i) { if(i % 3 == 0) printf(" ");
    if(i % 9 == 0) printf("\n"); ::printf("%d", aDstData[i]); }
    printf("\n");
    
    return 0;
}
//---------------------------------------------------------------------------
// --- original image data ---
// 111 222 333
// 444 555 666
// 777 888 999
// --- move [-1, -1] ---
// 555 666 000
// 888 999 000
// 000 000 000
// --- smaller region [2, 2] & clip x~<1, 2) y~<0, 3) ---
// 000 222 000
// 000 555 000
// 000 000 000
//---------------------------------------------------------------------------