//! \example _tests/fsBmfFnt/main.cpp
//---------------------------------------------------------------------------
#include <fs/ras/fsBmfFnt.h>

#include <stdio.h> // putchar
#include <cassert>
//---------------------------------------------------------------------------
int main()
{
    using namespace fs::ras;
    
    // simulate a RGBA-8888 bitmap surface
    const size_t w = 70;
    const size_t h = 20;
    BmfFnt_t::PxFmt8888_t aData[w * h] = { 0 };
    
    // load a BMF font
    BmfFnt_t Fnt("bringn12.bmf");
    assert(Fnt.IsValid() && "Couldn't load the BMF font!");
    
    // print text using the font
    Fnt.Print(0, 0, "HELLO!", aData, w, h);
    
    // show the surface
    for(int y = 0; y < h; ++y)
    {
        for(int x = 0; x < w; ++x)
        {
            ::putchar(aData[y * w + x].a ? 'o' : ' ');
        }
        ::putchar('\n');
    }

    return 0;
}
//---------------------------------------------------------------------------
//                                                         ooo
//                                                        oooo
//        oo                oo        oo                  ooooo
//  oo    oo      oooooo    oo        oo                  ooooo
//  ooo   oo     oooooooo   oo        oo          ooooo   ooooo
//   oo   oo     ooooooooo  oo        oo         ooooooo  oooo
//   oo    oo    oo    ooo   o         o        ooo   ooo ooo
//   ooooooooo   oo     ooo  o         o        oo     oo ooo
//   ooooooooo   oooooooooo  o         o        oo     oo oo
// ooooooooooo   oooooooooo oo        oo        o      oo oo
// oooooo   oo   ooo     oo oo   oooo oo   oooo ooo ooooo oo
// o   oo   ooo   ooooooooo ooooooooo ooooooooo ooooooooo
//     ooo  ooo    oooooooo oooooooo  oooooooo   oooooo
//     ooo   oo     oooooo  ooooo     ooooo
//      oo                  ooo       ooo                 ooo
//                                                        ooo
//---------------------------------------------------------------------------