//! \example _tests/fsDraw/main.cpp
//---------------------------------------------------------------------------
#include <fs/ras/fsDraw.h>

#include <stdio.h> // putchar
#include <cassert>
//---------------------------------------------------------------------------
int main()
{
    using namespace fs::ras;
    
    // simulate a RGBA-8888 bitmap surface
    const int w = 60;
    const int h = 20;
    nsDraw::PxFmt8888_t aData[w * h] = { 0 };
    
    const nsDraw::PxFmt8888_t Clr = { 255, 255, 255, 255 };
    
    // draw a line
    DrawLine<nsDraw::Cl8888DwPcy_t>(0, 0, w - 1, h - 1, Clr, aData, w, h);
    
    // draw two circles
    DrawCirc<nsDraw::Cl8888DwPcy_t>(w/2, h/2, h/2 - 1, Clr, aData, w, h);
    DrawCirc<nsDraw::Cl8888DwPcy_t>(w/2, h/2, h/4, Clr, aData, w, h);
    
    // show the surface
    for(int y = 0; y < h; ++y)
    {
        for(int x = 0; x < w; ++x)
        {
            ::putchar(aData[y * w + x].a ? 'o' : '.');
        }
        ::putchar('\n');
    }

    return 0;
}
//---------------------------------------------------------------------------
//oo..........................................................
//..ooo.......................ooooo...........................
//.....ooo..................oo.....oo.........................
//........ooo.............oo.........oo.......................
//...........ooo.........o.............o......................
//..............oooo.....o....ooooo....o......................
//..................ooo.o....o.....o....o.....................
//.....................ooo..o.......o...o.....................
//.....................o..ooo........o...o....................
//.....................o...o.ooo.....o...o....................
//.....................o...o....ooo..o...o....................
//.....................o...o.......ooo...o....................
//.....................o...o.........ooooo....................
//......................o...o.......o...oooo..................
//......................o....o.....o....o...oooo..............
//.......................o....ooooo....o........ooo...........
//.......................o.............o...........ooo........
//........................oo.........oo...............ooo.....
//..........................oo.....oo....................ooo..
//............................ooooo.........................oo
//---------------------------------------------------------------------------