//! \example _tests/fsFileDir/main.cpp
//---------------------------------------------------------------------------
#include <fs/sys/fsFileDir.h>

#include <stdio.h>
#include <string>
//---------------------------------------------------------------------------
int main()
{
    using namespace fs::sys::fdr;
    
    ::printf("path separator: '%s'\n", GetPathSpr());
    ::printf("startup directory: %s\n", GetAppDir());
    ::printf("is startup directory exist : %s\n",
     IsDirExist(GetAppDir()) ? "true" : "false");
    
    // decorate a path string
    {
        char szPath[] = "C:\\dir1////dir2\\dir3";
        ::printf("ugly path: %s\n", szPath);
        NicePath(szPath, szPath);
        ::printf("nice path: %s\n", szPath);
    }
    
    // create a directory structure
    {
        std::string strDir = GetAppDir();
        strDir.append("dir1").append(GetPathSpr());
        strDir.append("dir2").append(GetPathSpr());
        ::printf("create path: %s : %s\n", strDir.c_str(),
         MakeDir(strDir.c_str()) ? "true" : "false");
    }
    
    DirLst_t DirLst(GetAppDir(), true);
    for(int i = 0, n = DirLst.GetNum(); i < n; ++i)
    {
        ::printf("> %s\n", DirLst.GetAt(i));
    }
}
//---------------------------------------------------------------------------
// path separator: '\'
// startup directory: c:\!dev\fs\_tests\fsFileDir\_build_vc7\
// is startup directory exist : true
// ugly path: C:\dir1////dir2\dir3
// nice path: C:\dir1\dir2\dir3\
// create path: c:\!dev\fs\_tests\fsFileDir\_build_vc7\dir1\dir2\ : true
// > fsFileDir.ncb
// > fsFileDir.sln
// > fsFileDir.suo
// > fsFileDir.vcproj
// > main.cpp
// > Debug\BuildLog.htm
// > Debug\fsFileDir.exe
// > Debug\fsFileDir.ilk
// > Debug\fsFileDir.obj
// > Debug\fsFileDir.pdb
// > Debug\main.obj
// > Debug\vc70.idb
// > Debug\vc70.pdb
//---------------------------------------------------------------------------