//! \example _tests/fsMath/main.cpp
//---------------------------------------------------------------------------
#include <fs/fs_mth.h>

#include <cassert>
//---------------------------------------------------------------------------
int main()
{
    using namespace fs::mth;
    
    //---
    
    Vec2i_t v1(1, 2);
    Vec2i_t v2(3, 4);
    assert(v1 == v1);
    assert(v1 != v2);
            
    Vec2i_t v3(v1);
    v3 += v2;
    v3 -= v2;
    assert(v1 == v3);
    
    Vec2i_t v4(v1);
    v4 *= 2;
    assert(v4 == v1 + v1);
    assert(2 * v1 == v1 + v1);
    assert(v1 * 2 == v1 + v1);
    
    //---
            
    Rec2i_t r1(v1, v2);
    Rec2i_t r2(5, 6, 7, 8);
    assert(r1 == r1);
    assert(r1 != r2);
    assert(r1.Delta() == v2 - v1);
        
    return 0;
}
//---------------------------------------------------------------------------