//! \example _tests/fsSurfCl/main.cpp
//---------------------------------------------------------------------------
#include <fs/rap/fsSurfCl.h>
//---------------------------------------------------------------------------
using namespace fs::rap;
//---------------------------------------------------------------------------
namespace {
//---------------------------------------------------------------------------
SurfCl_t g_SurfCl(false, 512, 512);
//---------------------------------------------------------------------------
} // anonymous namespace
//---------------------------------------------------------------------------
namespace test {
//---------------------------------------------------------------------------
struct Client_t : public WinApp_t::EvRcvr_i
{
    virtual void OnEvent(const WinApp_t::InitEv_t &, WinApp_t &);
    virtual void OnEvent(const WinApp_t::RunEv_t &, WinApp_t &);
};
//---------------------------------------------------------------------------
void Client_t::OnEvent(const WinApp_t::InitEv_t &, WinApp_t &)
{
    SurfCl_t::PxFmt8888_t *pData = g_SurfCl.GetData();
            
    for(int y = 0, h = g_SurfCl.GetH(); y < h; ++y)
    {
        for(int x = 0, w = g_SurfCl.GetW(); x < w; ++x)
        {
            const SurfCl_t::PxFmt8888_t Clr = {
             static_cast<unsigned char>(x),
             static_cast<unsigned char>(y),
             0,
             0,
            };
        
            pData[w * y + x] = Clr;
        }
    }
}
//---------------------------------------------------------------------------
void Client_t::OnEvent(const WinApp_t::RunEv_t &, WinApp_t &App)
{
    static int i;
    ++i;
                        
    SurfCl_t::PxFmt8888_t *pData = g_SurfCl.GetData();
    for(int y = 0, h = g_SurfCl.GetH() / 2; y < h; ++y)
    {
        for(int x = 0, w = g_SurfCl.GetW(); x < w; ++x)
        {
            const SurfCl_t::PxFmt8888_t Clr = {
             static_cast<unsigned char>(x),
             static_cast<unsigned char>(y),
             static_cast<unsigned char>(x*y*i/1000),
             0
            };
        
            pData[w * y + x] = Clr;
        }
    }
    
    // send 'redraw' request
    App.Redraw();
}
//---------------------------------------------------------------------------
} // namespace test
//---------------------------------------------------------------------------
namespace fs { namespace rap {
//---------------------------------------------------------------------------
bool WinAppInit(WinApp_t &App, WinApp_t::InitCfg_t &Cfg)
{
    // modify default configuration
    Cfg.m_pszTitle = "SurfCl_t test";
    Cfg.m_nClW = 512;
    Cfg.m_nClH = 512;
    Cfg.m_bClrBgr = false;
    Cfg.m_bRtm = true; // enable 'run-time mode'
            
    // register event receivers, the order could be important
    static test::Client_t Client;
    App.RegEvRcvr(&g_SurfCl);
    App.RegEvRcvr(&Client);
        
    return true;
}
//---------------------------------------------------------------------------
}} // namespace fs::rapid
//---------------------------------------------------------------------------