//! \example _tests/fsWinApp/main.cpp
//---------------------------------------------------------------------------
#include <fs/rap/fsWinApp.h>

#include <stdio.h> // sprintf
#include <cassert>
//---------------------------------------------------------------------------
#if (_MSC_VER >= 1400) // MSVC8
#   pragma warning(disable : 4996) // function was marked as deprecated
#endif
//---------------------------------------------------------------------------
using namespace fs::rap;
//---------------------------------------------------------------------------
namespace test {
//---------------------------------------------------------------------------
struct Client_t : public WinApp_t::EvRcvr_i
{
    virtual void OnEvent(const WinApp_t::SizeEv_t &, WinApp_t &);
    virtual void OnEvent(const WinApp_t::KeyEv_t &, WinApp_t &);
    virtual void OnEvent(const WinApp_t::MouseEv_t &, WinApp_t &);
};
//---------------------------------------------------------------------------
void Client_t::OnEvent(const WinApp_t::SizeEv_t &SizeEv, WinApp_t &App)
{
    char szBuf[64];
    
    ::sprintf(szBuf, "Size Event: width = %d, height = %d",
     SizeEv.m_nClW, SizeEv.m_nClH);

    App.SetTitle(szBuf);
}
//---------------------------------------------------------------------------
void Client_t::OnEvent(const WinApp_t::KeyEv_t &KeyEv, WinApp_t &App)
{
    char szBuf[64];
    
    ::sprintf(szBuf, "Key Event: key code = %d (%s), mouse (%d, %d)",
     KeyEv.m_nKeyCode, KeyEv.m_bDown ? "down" : "up", KeyEv.m_nCurX,
     KeyEv.m_nCurY);

    App.SetTitle(szBuf);
}
//---------------------------------------------------------------------------
void Client_t::OnEvent(const WinApp_t::MouseEv_t &MouseEv, WinApp_t &App)
{
    char szBuf[64];
    
    ::sprintf(szBuf, "Mouse Event: x = %d, y = %d",
     MouseEv.m_nCurX, MouseEv.m_nCurY);

    App.SetTitle(szBuf);
}
//---------------------------------------------------------------------------
} // namespace test
//---------------------------------------------------------------------------
namespace fs { namespace rap {
//---------------------------------------------------------------------------
bool WinAppInit(WinApp_t &App, WinApp_t::InitCfg_t &Cfg)
{
    // modify default configuration
    Cfg.m_nClW = 512;
    Cfg.m_nClH = 512;
        
    // register event receivers (clients)
    static test::Client_t Client;
    App.RegEvRcvr(&Client);

    return true;
}
//---------------------------------------------------------------------------
}} // namespace fs::rap
//---------------------------------------------------------------------------