//! \example _tests/fsXmlDoc/main.cpp
//---------------------------------------------------------------------------
#include <fs/ut/fsXmlDoc.h>

#include <cstdio> // printf
#include <cassert>
//---------------------------------------------------------------------------
int main()
{
    fs::ut::XmlDoc_t Doc("test.xml");
    assert(Doc.IsValid() && "Couldn't load the XML document!"); 
        
    const char *pszFoldNm = 0;
    if(Doc.Query("folder/@name", pszFoldNm))
        ::printf("name of the first folder : '%s'\n", pszFoldNm);
         
    int nFiles = 0;
    if(Doc.Query("folder/#file", nFiles))
        ::printf("number of files in the first folder : %d\n", nFiles);
        
    const char *pszFile1Nm = 0;
    if(Doc.Query("folder/file/@name", pszFile1Nm))
        ::printf("name of the first file : '%s'\n", pszFile1Nm);
        
    const char *pszFile2Ct = 0;
    if(Doc.Query("folder/file^1", pszFile2Ct))
        ::printf("content of the second file : '%s'\n", pszFile2Ct);
        
    int nFile2Sz = 0;
    if(Doc.Query("folder/file^1/@size", nFile2Sz))
        ::printf("size of the second file : %d\n", nFile2Sz);
    
    int nFile2Tags = 0;
    if(Doc.Query("folder/file^1/#tag", nFile2Tags))
        ::printf("number of tags for the second file : %d\n", nFile2Tags);

    return 0;
}
//---------------------------------------------------------------------------
// name of the first folder : 'myfolder'
// number of files in the first folder : 2
// name of the first file : 'myfile1'
// content of the second file : 'some file2 data'
// size of the second file : 555
// number of tags for the second file : 2
//---------------------------------------------------------------------------
//<?xml version="1.0" encoding="UTF-8"?>
//    <folder name="myfolder">
//        <file name="myfile1"/>
//        <file name="myfile2" size="555">
//            some file2 data
//            <tag />
//            <tag />
//        </file>
//</folder>
//---------------------------------------------------------------------------