/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
/*                          _______      ______    ______          __      */
/*  ~ ~ ~ ~ ~ ~ ~ ~ ~ ~    / ____(_)___ / ___ /)  / ____/___  ____/ /__    */
/*      [fsRec2]          / /_  / / __ \\__ \|/  / /   / __ \/ __  / _ \   */
/*       rev. 2          / __/ / / /_/ /__/ /   / /___/ /_/ / /_/ /  __/   */
/*    20th Jan 2007     /_/   /_/ ,___/____/    \____/\____/\__,_/\___/    */
/*     [x] stable              /_/ (c) 2006-7 Filip STOKLAS (FipS)         */
/*  ~ ~ ~ ~ ~ ~ ~ ~ ~ ~       http://HOLE.4FipS.com/fips_code.php          */
/*                                                                         */
/* This code is free for personal and commercial use. You may redistribute */
/* it by any means. If you use the code for your own projects please give  */
/* me credit. Please send a bug report. Don't alter or remove this header! */
/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
#ifndef FS_MTH_FSREC2_H
#define FS_MTH_FSREC2_H
//---------------------------------------------------------------------------
#if defined(FS_INCLUDE_USERDEFS) // inject user definition file on request
#   include <fs/fsUserDefs.h>
#endif

#include "fsVec2.h"
//---------------------------------------------------------------------------
namespace fs { namespace mth {
//---------------------------------------------------------------------------
//! Rectangle representation (incomplete).
template <typename T>
class Rec2_T
{
 public:
 
    // --- CONSTRUCTION ---
 
    Rec2_T();
    Rec2_T(const Vec2_T<T> &p1, const Vec2_T<T> p2);
    Rec2_T(T x1, T y1, T x2, T y2);
    Rec2_T(const Rec2_T &RHS);
    
    // --- ASSIGMENT ---
    
    Rec2_T & operator = (const Rec2_T &RHS);
    
    // ---
    
    bool operator == (const Rec2_T &RHS) const;
    bool operator != (const Rec2_T &RHS) const;
     
    // --- OPERATIONS ---
    
    //! Returns the diagonal vector (p2 - p1).
    Vec2_T<T> Delta() const;
 
 public: // direct access is allowed
 
    Vec2_T<T> p1, p2;
};
//---------------------------------------------------------------------------
template <typename T>
inline Rec2_T<T>::Rec2_T() // does nothing
{
}
//---------------------------------------------------------------------------
template <typename T>
inline Rec2_T<T>::Rec2_T(const Vec2_T<T> &p1, const Vec2_T<T> p2):
p1(p1),
p2(p2)
{
}
//---------------------------------------------------------------------------
template <typename T>
inline Rec2_T<T>::Rec2_T(T x1, T y1, T x2, T y2):
p1(x1, y1),
p2(x2, y2)
{
}
//---------------------------------------------------------------------------
template <typename T>
inline Rec2_T<T>::Rec2_T(const Rec2_T &RHS) : p1(RHS.p1), p2(RHS.p2)
{
}
//---------------------------------------------------------------------------
template <typename T>
inline Rec2_T<T> & Rec2_T<T>::operator = (const Rec2_T &RHS)
{
    p1 = RHS.p1;
    p2 = RHS.p2;
    return *this;
}
//---------------------------------------------------------------------------
template <typename T>
inline bool Rec2_T<T>::operator == (const Rec2_T &RHS) const
{
    return p1 == RHS.p1 && p2 == RHS.p2;
}
//---------------------------------------------------------------------------
template <typename T>
inline bool Rec2_T<T>::operator != (const Rec2_T &RHS) const
{
    return p1 != RHS.p1 || p2 != RHS.p2;
}
//---------------------------------------------------------------------------
template <typename T>
inline Vec2_T<T> Rec2_T<T>::Delta() const
{
    return Vec2_T<T>(p2.x - p1.x, p2.y - p1.y);
}
//---------------------------------------------------------------------------
}} // namespace fs::mth
//---------------------------------------------------------------------------
#endif // FS_MTH_FSREC2_H