/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
/*                          _______      ______    ______          __      */
/*  ~ ~ ~ ~ ~ ~ ~ ~ ~ ~    / ____(_)___ / ___ /)  / ____/___  ____/ /__    */
/*     [fsCl8888]         / /_  / / __ \\__ \|/  / /   / __ \/ __  / _ \   */
/*       rev. 2          / __/ / / /_/ /__/ /   / /___/ /_/ / /_/ /  __/   */
/*    5th Feb 2007      /_/   /_/ ,___/____/    \____/\____/\__,_/\___/    */
/*     [ ] stable              /_/ (c) 2006-7 Filip STOKLAS (FipS)         */
/*  ~ ~ ~ ~ ~ ~ ~ ~ ~ ~       http://HOLE.4FipS.com/fips_code.php          */
/*                                                                         */
/* This code is free for personal and commercial use. You may redistribute */
/* it by any means. If you use the code for your own projects please give  */
/* me credit. Please send a bug report. Don't alter or remove this header! */
/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
#ifndef FS_RAS_FSCL8888_H
#define FS_RAS_FSCL8888_H
//---------------------------------------------------------------------------
#if defined(FS_INCLUDE_USERDEFS) // inject user definition file on request
#   include <fs/fsUserDefs.h>
#endif
//---------------------------------------------------------------------------
namespace fs { namespace ras {
//---------------------------------------------------------------------------
//! RGBA-8888 color representation (incomplete).
class Cl8888_t
{
 public:
 
    Cl8888_t() {}
    Cl8888_t(unsigned char r, unsigned char g, unsigned char b,
     unsigned char a = 255) : r(r), g(g), b(b), a(a) {}

    bool operator == (const Cl8888_t &RHS) const
     { return r == RHS.r && g == RHS.g && b == RHS.b && a == RHS.a; }
 
 public: // direct access is allowed
 
    unsigned char r, g, b, a;
};
//---------------------------------------------------------------------------
}} // namespace fs::ras
//---------------------------------------------------------------------------
#endif // FS_RAS_FSCL8888_H