/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
/*                          _______      ______    ______          __      */
/*  ~ ~ ~ ~ ~ ~ ~ ~ ~ ~    / ____(_)___ / ___ /)  / ____/___  ____/ /__    */
/*      [fsAssert]        / /_  / / __ \\__ \|/  / /   / __ \/ __  / _ \   */
/*       rev. 32         / __/ / / /_/ /__/ /   / /___/ /_/ / /_/ /  __/   */
/*    25th Jan 2007     /_/   /_/ ,___/____/    \____/\____/\__,_/\___/    */
/*     [x] stable              /_/ (c) 2004-7 Filip STOKLAS (FipS)         */
/*  ~ ~ ~ ~ ~ ~ ~ ~ ~ ~       http://HOLE.4FipS.com/fips_code.php          */
/*                                                                         */
/* This code is free for personal and commercial use. You may redistribute */
/* it by any means. If you use the code for your own projects please give  */
/* me credit. Please send a bug report. Don't alter or remove this header! */
/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
#include <fs/sys/fsAssert.h>
//---------------------------------------------------------------------------
#if defined(_WIN32)
#   if defined(FS_ASSERT_ENABLE_BOX)
#       include <stdio.h> // string stuff
#   endif
#endif
//---------------------------------------------------------------------------
#if defined(_WIN32)
#   if defined(FS_ASSERT_ENABLE_BOX) || defined(FS_ASSERT_ENABLE_BEEP)
#       include <windows.h> // MessageBox, Beep, process stuff
#   endif
#endif
//---------------------------------------------------------------------------
#if (_MSC_VER >= 1400) // MSVC8
#   pragma warning(disable : 4996) // function was marked as deprecated
#endif
//---------------------------------------------------------------------------
#if defined(_WIN32) && defined(FS_ASSERT_ENABLE_BOX)
namespace {
//! Strips a file name from a path.
const char * StripFn(const char *pszPath)
{
    const char *p1 = strrchr(pszPath, '/');
    const char *p2 = strrchr(pszPath, '\\');
    return p1 > p2 ? p1 + 1 : p2 > p1 ? p2 + 1 : pszPath;
}}
#endif
//---------------------------------------------------------------------------
#if defined(_WIN32) && defined(FS_ASSERT_ENABLE_BOX)
bool fs::sys::asr::BoxWin(const char *pszExp, const char *pszMsg,
 const char *pszFunc, const char *pszFile, int nLine)
{
#if defined(FS_ASSERT_LABEL)
    const char *pszLabel = FS_ASSERT_LABEL;
#else
    const char pszLabel[] = "???";
#endif

    char szBuf[1024]; sprintf(szBuf,
    
     "%s\n" // label
     "------------------------------------        \n"
     "msg:\t%s\n"
     "exp:\t%s\n"
     "func:\t%s\n"
     "file:\t%s\n"
     "line:\t%d\n"
     "------------------------------------        \n"
     "Would you like to debug now?",
     
     pszLabel,
     pszMsg ? pszMsg : "-",
     pszExp ? pszExp : "???",
     pszFunc ? pszFunc : "???",
     pszFile ? StripFn(pszFile) : "???",
     nLine
     
    );

#if defined(UNICODE) // especially WinCE

    wchar_t wszBuf[1024]; size_t i = 0; while(i < 1024) { char ch =
     szBuf[i]; wszBuf[i] = ch; if(ch == '\0') break; ++i; }


    if(MessageBox(0, wszBuf, L"ASSERT WARNING",
     MB_ICONWARNING | MB_YESNO) == IDYES)
        return true;

#else

    if(MessageBoxA(0, szBuf, "ASSERT WARNING",
     MB_ICONWARNING | MB_YESNO) == IDYES)
        return true;

#endif
                
    return false;
}
#endif
//---------------------------------------------------------------------------
#if defined(_WIN32) && defined(FS_ASSERT_ENABLE_BEEP)
void fs::sys::asr::BeepWin()
{
#if !defined(UNDER_CE)
    Beep(300, 100);
#else
    //! \todo Is this better than Beep ???
    MessageBeep(0xFFFFFFFF);
#endif
}
#endif
//---------------------------------------------------------------------------
#if defined(UNDER_CE) && defined(FS_ASSERT_ENABLE_BOX)
void fs::sys::asr::BreakWce()
{
    TerminateProcess(GetCurrentProcess(), 0);
}
#endif
//---------------------------------------------------------------------------