/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
/*                          _______      ______    ______          __      */
/*  ~ ~ ~ ~ ~ ~ ~ ~ ~ ~    / ____(_)___ / ___ /)  / ____/___  ____/ /__    */
/*      [fsTplUt]         / /_  / / __ \\__ \|/  / /   / __ \/ __  / _ \   */
/*       rev.  4         / __/ / / /_/ /__/ /   / /___/ /_/ / /_/ /  __/   */
/*    15th Jan 2007     /_/   /_/ ,___/____/    \____/\____/\__,_/\___/    */
/*     [x] stable              /_/ (c) 2006-7 Filip STOKLAS (FipS)         */
/*  ~ ~ ~ ~ ~ ~ ~ ~ ~ ~       http://HOLE.4FipS.com/fips_code.php          */
/*                                                                         */
/* This code is free for personal and commercial use. You may redistribute */
/* it by any means. If you use the code for your own projects please give  */
/* me credit. Please send a bug report. Don't alter or remove this header! */
/*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*/
#ifndef FS_UT_FSTPLUT_H
#define FS_UT_FSTPLUT_H
//---------------------------------------------------------------------------
#if defined(FS_INCLUDE_USERDEFS) // inject user definition file on request
#   include <fs/fsUserDefs.h>
#endif
//---------------------------------------------------------------------------
namespace fs { namespace ut {
//---------------------------------------------------------------------------
//! <b>T</b>em<b>pl</b>ate utilities.
namespace tpl {
//---------------------------------------------------------------------------
//! Type generator based on an integral constant. 
/*! The template <b>generates</b> a <b>distinct type</b> for each distinct
    <b>constant integral value</b> passed /AA/. It can be used as a
    <b>compile-time code switch</b> based on a compile-time constant. More
    information can be found
    <a href="http://hole.4fips.com/cpp.cpp_tips.php#tip5">here</a>.
*/
template <int n>
struct Int2Type_T
{
    enum { Value = n };
};
//---------------------------------------------------------------------------
}}} // namespace fs::ut::tpl
//---------------------------------------------------------------------------
#endif // FS_UT_FSTPLUT_H